<template>
  <div>
    <p class="title-subheadline text-center">
      <span v-if="onVerify">
        Please enter the code sent to {{ form.email }}
      </span>
    </p>

    <q-form @submit.prevent="submit(form)" class="q-mt-lg">
      <div class="q-py-xs" v-if="onEmail">
        <label class="text-caption text-weight-bold text-grey-7"
          >EMAIL ADDRESS</label
        >
        <q-input
          dense
          outlined
          color="primary"
          v-model="form.email"
          class="q-mt-sm"
          :rules="[validations.requiredField, validations.emailFormat]"
        />
      </div>

      <div class="row" v-if="onVerify">
        <div class="col-12 flex justify-center">
          <v-otp-input
            v-model="form.forgot_password_code"
            ref="otpInput"
            input-classes="otp-input"
            separator=""
            :num-inputs="6"
            :should-auto-focus="true"
            @on-change="handleOnChange"
            @on-complete="handleOnComplete"
            :rules="[validations.requiredField]"
          />
        </div>
      </div>

      <div class="q-py-xs" v-if="onPassword">
        <label class="text-caption text-weight-bold text-grey-7"
          >PASSWORD</label
        >
        <q-input
          dense
          outlined
          color="primary"
          v-model="form.password"
          :type="isFieldPassword ? 'password' : 'text'"
          class="q-mt-sm"
          :rules="[validations.requiredField]"
        >
          <template v-slot:append>
            <q-icon
              :name="
                isFieldPassword ? 'eva-eye-off-outline' : 'eva-eye-outline'
              "
              @click="isFieldPassword = !isFieldPassword"
            />
          </template>
        </q-input>
      </div>

      <div class="q-py-xs" v-if="onPassword">
        <label class="text-caption text-weight-bold text-grey-7"
          >CONFIRM PASSWORD</label
        >
        <q-input
          dense
          outlined
          color="primary"
          v-model="form.confirmation_password"
          :type="isFieldConfirmPassword ? 'password' : 'text'"
          class="q-mt-sm"
          :rules="[validations.requiredField]"
        >
          <template v-slot:append>
            <q-icon
              :name="
                isFieldConfirmPassword
                  ? 'eva-eye-off-outline'
                  : 'eva-eye-outline'
              "
              @click="isFieldConfirmPassword = !isFieldConfirmPassword"
            />
          </template>
        </q-input>
      </div>

      <p class="text-negative text-center">
        {{ errorMessage }}
      </p>

      <div class="row form__actions q-mt-lg" align="center">
        <div class="col px-0">
          <q-btn
            unelevated
            type="submit"
            class="btn-xl btn--shade-1 title-4 text-white rounded-borders-10"
            :loading="loading"
          >
            {{ step.buttonText }}
          </q-btn>
        </div>
      </div>
    </q-form>
  </div>
</template>

<script>
import { requiredField, emailFormat } from "src/hooks/validations";
import { defineComponent, ref, reactive, computed } from "vue";
import { LocalStorage } from "quasar";
import usePageRouter from "src/hooks/pageRouter";
import useNotification from "src/hooks/notification";

import {
  ForgotPasswordApi,
  EmployerUserApi,
  JobseekerUserApi,
} from "src/hooks/api";
import VOtpInput from "vue3-otp-input";
import { getErrorMessage } from "src/hooks/errorMessage";

export default defineComponent({
  name: "ForgotPasswordForm",
  components: {
    VOtpInput,
  },

  setup() {
    const { router } = usePageRouter();
    const { showNotif } = useNotification();
    const loading = ref(false);
    const currentStep = ref(0);
    const otpInput = ref(null);
    const isError = ref(false);
    const errorMessage = ref("");
    const USER_ROLE = ref("");
    const USER_ID = ref(null);

    const STEPS = reactive([
      {
        buttonText: "Reset Password",
      },
      {
        buttonText: "Submit",
      },
      {
        buttonText: "Reset password",
      },
    ]);

    const form = reactive({
      email: null,
      password: null,
      confirmation_password: null,
      forgot_password_code: null,
    });
    const isFieldPassword = ref(true);
    const isFieldConfirmPassword = ref(true);

    const handleOnComplete = (value) => {
      form.forgot_password_code = value;
    };

    const handleOnChange = (value) => {
      form.forgot_password_code = value;
    };

    const step = computed(() =>
      !currentStep.value ? STEPS[0] : STEPS[currentStep.value]
    );

    const onEmail = computed(() => {
      return step.value === STEPS[0];
    });

    const onVerify = computed(() => {
      return step.value === STEPS[1];
    });

    const onPassword = computed(() => {
      return step.value === STEPS[2];
    });

    const submit = async (payload) => {
      await next(payload).then(() => {
        if (isError.value === false) {
          if (onPassword.value) {
            this.$emit("success");
          } else {
            nextStep();
          }
        }
      });
    };

    const next = async (payload) => {
      loading.value = true;
      isError.value = false;

      if (onEmail.value) {
        await ForgotPasswordApi.sendCode(payload)
          .then((response) => {
            USER_ROLE.value = response.data.data.user_type;
            USER_ID.value = response.data.data.id;
          })
          .catch((error) => {
            isError.value = true;
            // errorMessage.value = error?.response?.data?.message.toUpperCase();
            showNotif({
              message: getErrorMessage(error),
              color: "negative",
              position: "bottom-right",
            });
            loading.value = false;
          })
          .finally(() => {
            loading.value = false;
          });
      }
      if (onVerify.value) {
        await ForgotPasswordApi.verifyCode(payload)
          .then((response) => {
            LocalStorage.set("role", response.data.data.user.user_type);
            LocalStorage.set("authenticated", true);
            LocalStorage.set("token", response.data.data.access_token);
            LocalStorage.set("auth", response.data.data.user);
          })
          .catch((error) => {
            isError.value = true;
            errorMessage.value = getErrorMessage(error).toUpperCase();
            loading.value = false;
          })
          .finally(() => {
            loading.value = false;
          });
      } else if (onPassword.value) {
        let API_FUNCTION =
          USER_ROLE.value === "job-seeker" ? JobseekerUserApi : EmployerUserApi;

        if (form.password !== form.confirmation_password) {
          isError.value = true;
          errorMessage.value = "PASSWORDS MUST MATCH.";
          loading.value = false;
        } else {
          await API_FUNCTION.updatePassword(USER_ID.value, payload)
            .then((response) => {
              showNotif({
                message: "Success! You will be redirected to Login page.",
                color: "positive",
                position: "bottom-right",
              });

              setTimeout(() => {
                if (response.data.success === true) {
                  router.push("login");
                }
              }, 2000);
            })
            .catch((error) => {
              isError.value = true;
              errorMessage.value = getErrorMessage(error).toUpperCase();
              loading.value = false;
            })
            .finally(() => {
              loading.value = false;
            });
        }
      } else {
        return null;
      }
    };

    const nextStep = () => {
      const nextStep = currentStep.value + 1;
      currentStep.value = nextStep > STEPS.length - 1 ? 0 : nextStep;
    };

    return {
      loading,
      form,
      isFieldPassword,
      isFieldConfirmPassword,
      currentStep,
      isError,
      errorMessage,
      otpInput,
      USER_ID,
      USER_ROLE,
      STEPS,
      step,
      onEmail,
      onVerify,
      onPassword,
      userEmail: computed(() => LocalStorage.getItem("auth").email),
      validations: {
        requiredField,
        emailFormat,
      },
      handleOnComplete,
      handleOnChange,
      submit,
      getErrorMessage,
    };
  },
});
</script>

<style>
.otp-input {
  width: 40px;
  height: 40px;
  padding: 5px;
  margin: 0 10px;
  font-size: 20px;
  border-radius: 10px;
  border: 1px solid rgba(0, 0, 0, 0.3);
  text-align: center;
}
/* Background colour of an input field with value */
.otp-input.is-complete {
  border-color: primary;
}
.otp-input::-webkit-inner-spin-button,
.otp-input::-webkit-outer-spin-button {
  -webkit-appearance: none;
  margin: 0;
}
input::placeholder {
  font-size: 15px;
  text-align: center;
  font-weight: 600;
}

a {
  cursor: pointer;
}
</style>
